package WC;

import RM.MyRM;
import RM.*;
import java.rmi.*;
import Resources.*;

public class MyWC extends java.rmi.server.UnicastRemoteObject 
		  implements Remote
{

    static IResourceManager carRM;
    static IResourceManager flightRM;
    static IResourceManager roomRM;
    static IResourceManager customerRM;

    public MyWC()throws java.rmi.RemoteException{}


    /**
     * For the following methods, the WC should start a transaction, invoke the 
     * appropriate RM and commit or abort the operation
     * The logic of the operation is exactly the one described in IResourceManager
     */
    public boolean addFlight(int flight, int flightSeats, int flightPrice)
	throws RemoteException, 
	       TransactionAbortedException,
	       InvalidTransactionException
    {
	int context=0; //TransactionManager.start();
	boolean result=false; //flightRM.add(context, new ReservableElement(flight),flightSeats,flightPrice);
	flightRM.commit(context);
	return result;
    }

    public boolean deleteFlight(int flight)
	throws RemoteException, 
	       TransactionAbortedException,
	       InvalidTransactionException
    {
	return false;
    }

    public boolean addCars(String location, int numCars, int price)
	throws RemoteException, 
	       TransactionAbortedException,
	       InvalidTransactionException
    {
	return false;
    }

    public boolean deleteCars(String location, int numCars)
	throws RemoteException, 
	       TransactionAbortedException,
	       InvalidTransactionException
    {
	return false;
    }

    public boolean addRooms(String location, int numRooms, int price)
	throws RemoteException, 
	       TransactionAbortedException,
	       InvalidTransactionException
    {
	return false;
    }

    public boolean deleteRooms(String location, int numRooms)
	throws RemoteException, 
	       TransactionAbortedException,
	       InvalidTransactionException
    {
	return false;
    }

    public int queryFlight( int flight)throws RemoteException, 
	    TransactionAbortedException,
	    InvalidTransactionException
    {
	return 0;
    }

    public int queryFlightPrice(int flight)throws RemoteException, 
	    TransactionAbortedException,
	    InvalidTransactionException
    {
	return 0;
    }

    public int queryRooms(String location)throws RemoteException, 
	    TransactionAbortedException,
	    InvalidTransactionException
    {
	return -1;
    }

    public int queryRoomsPrice(String location)throws RemoteException, 
	    TransactionAbortedException,
	    InvalidTransactionException
    {
	return 0;
    }
    public int queryCars( String location)throws RemoteException, 
	    TransactionAbortedException,
	    InvalidTransactionException
    {
	return 0;
    }

    public int queryCarsPrice( String location)throws RemoteException, 
	    TransactionAbortedException,
	    InvalidTransactionException
    {
	return 0;
    }
    

    public int newCustomer(int context)throws RemoteException
    {
       return -1;
    }

    public boolean deleteCustomer(int customer) throws RemoteException
    {
	return false;
    }

    public boolean reserveFlight(int customer, int flight)throws RemoteException,
	    TransactionAbortedException, InvalidTransactionException
    {
	return false;
    }

    public boolean reserveCar(int customer, String location)throws RemoteException,
	    TransactionAbortedException, InvalidTransactionException
    {
	return false;
    }

    public boolean reserveRoom(int customer, String location)throws RemoteException,
	    TransactionAbortedException, InvalidTransactionException
    {
	return false;
    }

    public boolean reserveItinerary( int customer, int [] flights, String location, boolean car, boolean room )throws RemoteException
    {
	// Get a unique transaction id from the TM
	int tid = 0; //TransactionManager.start();
	
	boolean success = false;
		if(car)
		    // success= carRM.reserve( tid, customer,new ReservableElement(location));
		    ;
		if(room)
		    // success=roomRM.reserve( tid, customer,new ReservableElement (location));
		    ;
		for(int i=0;i<flights.length;i++)
		    //success=flightRM.reserve( tid, customer, new ReservableElement( flights[i]));
			;
		if (success)
		{
		    carRM.commit( tid );
		    flightRM.commit(tid );
		    roomRM.commit(tid );
		}
		else
		   {
		      carRM.abort( tid );
		      flightRM.abort( tid );
		      roomRM.abort( tid );

		     return false;
		   }
		
	return true;
    }		
   
    public int queryCustomer(int customer)throws RemoteException
    {
	return 0;
    }

    public String queryCustomerInfo(int customer)throws RemoteException,
	    TransactionAbortedException, InvalidTransactionException
    {
	return "This will be a serialization of the customers reservations";
    }


    /** 
     * This is a stand-alone server process
     * loop waiting for clients to connect
     */
    public static void main(String [] args )
    {

	String rm_name="";
	
	if (System.getSecurityManager() == null) 
	{
            System.setSecurityManager(new RMISecurityManager());
        }
	
	String rmFlights="flightRM";
	String rmRooms="roomRM";
	String rmCars="carRM";
	String rmCustomers="customerRM";

	String name ="";	

        if (args.length < 5) 
	{
            System.err.println("Usage: WC.MyWC <name> [<RM_name>]");
	    name="testWC";
        }
        else 
	   {
	      name	  = args[0];
	      rmFlights	  = args[1];
	      rmRooms	  = args[2];
	      rmCars	  = args[3];
	      rmCustomers = args[4];
	   }


	try 
	{
	      carRM 	 = (IResourceManager)Naming.lookup(rmCars);
	      flightRM 	 = (IResourceManager)Naming.lookup(rmFlights);
	      roomRM	 = (IResourceManager)Naming.lookup(rmRooms);
	      customerRM = (IResourceManager)Naming.lookup(rmCustomers);
	} 
	catch (RemoteException e) 
	{
     	   e.detail.printStackTrace();
	} 
	catch (Exception e) 
	{
	   e.printStackTrace();
        }

        // Bind the WC and begin processing requests.
        try 
	{
            MyWC wc = new MyWC();
            Naming.rebind(name, wc);
	}
        catch (Exception e) 
	{
            System.err.println(name + " not bound:" + e);
        }
	
    }
}
